<?php
if(!defined("CONF_READ")) include_once('inc/config.php');
$index_list = array('index.html', 'index.htm', 'index.cgi', 'index.php', 'index.xhtm', 'index.shtml', 'index.shtm', 'index.xcg', 'index.hdml');

class WriteClass{
	//debug
	function debug($data){
		echo "<XMP>";
		print_r($data);
		echo "</XMP>";
		exit;
	}
	//SQL
	function quote_smart($value, $type=0){
		if(constant("ENC_FLG") && !$type) $value = @mb_convert_encoding($value, "EUC-JP", constant("TO_ENCODING"));
		if(get_magic_quotes_gpc()) $value = stripslashes($value);
		if (!is_numeric($value) && !$type){
			return "'".mysql_real_escape_string($value)."'";
		}else{
			return mysql_real_escape_string($value);
		}
	}
	//顼å
	function check_err($db){
		if(DB::isError($db)){
			echo "<font color=\"#CC0000\"><b>DB Error:</b>&nbsp;";
			if(constant("DB_TYPE") == "mysql"){
				echo mysql_error();
			}else{
				echo DB::errorMessage($db);
			}
			$db->query("UNLOCK TABLES");
			$db->disconnect();
			die("</font>");
		}
	}
	//󥿡
	function mk_counter($num = 0){
		if($num){
			$num = str_pad($num, constant("COUNTER_DIGIT"), "0", STR_PAD_LEFT);
			$counter = array("width" => 0,"height" => 0);
			while(strlen($num)){
				$n = substr($num, 0, 1);
				$num = substr($num, 1);
				list($width, $height) = getimagesize(constant("COUNTER_DIR").$n.".png");
				$counter["num"][] = $n;
				$counter["width"] += $width;
				if($counter["height"] < $height) $counter["height"] = $height;
			}
			
			if($im = @imagecreate($counter["width"], $counter["height"])){
				$set_w = 0;
				foreach ($counter["num"] as $v) {
					list($width, $height) = getimagesize(constant("COUNTER_DIR").$v.".png");
					$src_im = imagecreatefrompng(constant("COUNTER_DIR").$v.".png");
					imagecopy($im, $src_im,
					$set_w, 0,
					0, 0,
					$width, $height);
					imagedestroy($src_im);
					$set_w += $width;
				}
				header("Content-type: image/png"); 
				imagepng($im);
				imagedestroy($im);
				exit;
			}
		}else{
			header("Content-Type: image/gif");
			echo base64_decode("R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==");
			exit;
		}
		exit;
	}
	//ȥ
	function get_title($path){
		if(!$path) return;
		
		$title = "";
		$d = "";
		switch(constant("GET_TITLE_MODE")){
		    case 0:
				return;
				break;
		    case 1:
				//ե뤫饿ȥ
				if(defined("MOGURA_PATH") && !constant("PHP_WRITE_MODE")){
					$temp_path = strtok($path, '?');
					$url = (strrpos($temp_path, '/') === strlen($temp_path) - 1) ? '' : basename($temp_path);
				}else{
					$url = str_replace(dirname($_SERVER["PHP_SELF"] ? strtok($_SERVER["PHP_SELF"], '?') : $_SERVER["SCRIPT_NAME"]), '', dirname(__FILE__)).'/';
					$temp_path = strtok($path, '?');
					$url .= $temp_path;
				}
				if(strrpos($temp_path, '/') === strlen($temp_path) - 1){
					global $index_list;
					foreach($index_list as $index){
						if(file_exists($url.$index)){
							$url .= $index;
							break;
						}
					}
				}
				if(function_exists('file_get_contents')){
					$d = @file_get_contents($url);
				}else{
					$d = @implode('',@file($url));
				}
				break;
		    case 2:
				//URI饿ȥ
				$url = "http://".$_SERVER["HTTP_HOST"].$path;
				
				if($_SERVER["QUERY_STRING"]){
					$url .= "?".$_SERVER["QUERY_STRING"]."&GET_TITLE";
				}else{
					$url .= "?GET_TITLE";
				}
				if(function_exists('file_get_contents')){
					$d = @file_get_contents($url);
				}else{
					$d = @implode('',@file($url));
				}
				break;
		}
		if($d){
			$d = @mb_convert_encoding($d, "EUC-JP", constant("TO_ENCODING"));
			preg_match("/<title[^>]*>([^<]*)<\/title>/i",$d,$t);
			$title = trim($t[1]);
		}
		return $title;
	}
	//˻ͤ뤫å
	function inc_array($str,$arr){
		$str = trim($str);
		$retval = FALSE;
		if(is_array($arr) && $str != ""){
			foreach($arr as $v){
				$v = trim($v);
				if($v == "") continue;
				if(stristr($v, $str) != ""){
					$retval = TRUE;
					break;
				}
			}
		}
		return $retval;
	}
	
	//ݥꥹȤɤ߹
	function get_exclude($db){
		$res = $db->query("SELECT * FROM ".constant("DB_EXCLUDE").";");
		WriteClass::check_err($res);
		while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)){
			$exclude[$row["exclude_type"]][] = $row["exclude_val"];
		}
		$res->free();
		
		return $exclude;
	}

}
/*=================================================*/
/* ⡼[PHP]ѥ󥿡                     */
/*=================================================*/
$mode = (isset($_GET["mode"]) ? $_GET["mode"] : "php");
if($mode != "img") $mode = "php";
if($mode == "php" && isset($_GET["counter"])) WriteClass::mk_counter($_GET["counter"]);

/*=================================================*/
/* ᥤ                                      */
/*=================================================*/
// DB³
$db = DB::connect(constant("DSN"));
// 顼å
if(DB::isError($db)) WriteClass::check_err($db);
$db->query("SET NAMES UJIS;");
$write_flg = true;

//-------------------------------------
//  ̥ǡ
//-------------------------------------
//
$w3a_buf = array();
//IP
if(isset($_SERVER['HTTP_X_FORWARDED_FOR'])
&& ereg('^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$',$_SERVER['HTTP_X_FORWARDED_FOR'])){
	$w3a_buf["ip"] = $_SERVER['HTTP_X_FORWARDED_FOR'];
}else{
	$w3a_buf["ip"] = $_SERVER["REMOTE_ADDR"];
}
//ID
$w3a_buf["id"] = "";
if(isset($_COOKIE["w3a"]["id"])){
	$w3a_buf["id"] = $_COOKIE["w3a"]["id"];
}else{
	foreach(explode(".", $w3a_buf["ip"]) as $v){ $w3a_buf["id"] .= dechex($v); }
}
if($w3a_buf["id"]) @setcookie("w3a[id]",$w3a_buf["id"],time()+60*60*24*constant("COOKIE_EXPIRE"),'/');
//date
$w3a_buf["date"] = gmdate("Y-m-d H:i:s", time()+constant("TIME_DIFF")*3600);
//HOST
$w3a_buf["host"] = @gethostbyaddr($w3a_buf["ip"]);

if(getcwd() == dirname(__FILE__) && $mode != "img"){
	$direct_access = isset($_GET["mogura_path"]) ? false : true;
}else{
	$direct_access = false;
}
define ("ENC_FLG", preg_match("/^(EUC-JP)$/i", mb_http_input("G")) ? true : false);

if($direct_access){
	//-------------------------------------
	//  ɥ󥿡
	//-------------------------------------
	if(!isset($_GET["dl"])){
		//DB³λ/å
		$db->query("UNLOCK TABLES");
		$db->disconnect();
		die("Direct Access Error.");
	}
	$write_flg = true;
	//å
	$db->query("LOCK TABLES ".constant("DB_TABLE_LOG")." WRITE,".constant("DB_EXCLUDE")." READ");
	//ݥꥹȤɤ߹
	$exclude = WriteClass::get_exclude($db);
	//DL
	$w3a_buf["dl"] = $_GET["dl"];
	
	//-------------------------------------
	//  ݽ
	//-------------------------------------
	if($write_flg && WriteClass::inc_array($w3a_buf["id"], $exclude["id"])) $write_flg = false;
	if($write_flg && WriteClass::inc_array($w3a_buf["host"], $exclude["host"])) $write_flg = false;
	if($write_flg && WriteClass::inc_array($w3a_buf["ip"], $exclude["host"])) $write_flg = false;
	if($write_flg && WriteClass::inc_array($_SERVER["HTTP_USER_AGENT"], $exclude["ua"])) $write_flg = false;
	//-------------------------------------
	//  ɲ
	//-------------------------------------
	if($write_flg){
		while (list ($k, $v) = each ($w3a_buf)) {
			$v = trim($v);
			if($v == "") continue;
			
			$sql_k .= WriteClass::quote_smart($k, 1).",";
			$sql_v .= WriteClass::quote_smart($v).",";
		}
		$sql_k = "(".substr($sql_k,0,strlen($sql_k)-1).")";
		$sql_v = " VALUES (".substr($sql_v,0,strlen($sql_v)-1).")";
		$sql = "INSERT INTO ".constant("DB_TABLE_LOG")." ".$sql_k.$sql_v.";";
		$res = $db->query($sql);
		if(DB::isError($res)){
			WriteClass::check_err($res);
			//DB³λ/å
			$db->query("UNLOCK TABLES");
			$db->disconnect();
		}
		//ʾΥ
		if(constant("MAX_LOG")){
			$res = $db->query("SELECT no FROM ".constant("DB_TABLE_LOG")." order by no desc limit ".constant("MAX_LOG").",1;");
			if($res->numRows()){
				$row = $res->fetchRow(DB_FETCHMODE_ASSOC);
				$db->query("DELETE FROM ".constant("DB_TABLE_LOG")." WHERE no <= ".$row["no"].";");
			}
		}
	}
	//DB³λ/å
	$db->query("UNLOCK TABLES");
	$db->disconnect();
	//Location
	header("Location: ".$_GET["dl"]);
	exit;
}elseif(constant("ACC_RUN") || (!isset($_GET["GET_TITLE"]) && $mode == "php")){
	//-------------------------------------
	//  ̾
	//-------------------------------------
	//ʸ󥳡ǥ
	$def_enc = @mb_internal_encoding();
	@mb_internal_encoding("EUC-JP");
	
	//å
	$db->query("LOCK TABLES "
	.constant("DB_TABLE_LOG")." WRITE,"
	.constant("DB_TABLE_UA")." WRITE,"
	.constant("DB_COUNTER")." WRITE,"
	.constant("DB_EXCLUDE")." READ"
	);
	//ݥꥹȤɤ߹
	$exclude = WriteClass::get_exclude($db);
	
	//Path
	if(isset($_GET["path"])){
		$w3a_buf["path"] = $_GET["path"];
	}else{
		if(getcwd() == dirname(__FILE__)){
			if(isset($_SERVER["HTTP_REFERER"])){
				$w3a_buf["path"] = ereg_replace("(https?|ftp|news)(://[[:alnum:]\+\$\;\?\.%,!#~*:@&=_-]+)(/.*)","\\3",$_SERVER["HTTP_REFERER"]);
			}else{
				$w3a_buf["path"] = "";
			}
		}else{
			$w3a_buf["path"] = $_SERVER["PHP_SELF"] ? $_SERVER["PHP_SELF"] : $_SERVER["SCRIPT_NAME"];
			if($_SERVER["QUERY_STRING"]) $w3a_buf["path"] = $w3a_buf["path"]."?".$_SERVER["QUERY_STRING"];
		}
	}
	
	//Referer
	if(isset($_GET["ref"])){
		$w3a_buf["ref"] = $_GET["ref"];
	}else{
		if(getcwd() == dirname(__FILE__)){
			$w3a_buf["ref"] = "";
		}else{
			if(isset($_SERVER["HTTP_REFERER"])) $w3a_buf["ref"] = $_SERVER["HTTP_REFERER"];
		}
	}
	if(isset($w3a_buf["ref"])){
		$w3a_buf["ref"] = @mb_convert_encoding($w3a_buf["ref"], "EUC-JP", "ASCII,JIS,UTF-8,EUC-JP,SJIS");
		$w3a_buf["ref_q"] = strstr($w3a_buf["ref"], '?');
		if($w3a_buf["ref_q"]){
			$w3a_buf["ref"] = str_replace ($w3a_buf["ref_q"], "", $w3a_buf["ref"]);
			$w3a_buf["ref_q"] = substr($w3a_buf["ref_q"], 1);
		}
	}
	
	//Title
	$get_title = array();
	$get_title['send_title'] = isset($_GET["send_title"]) ? trim($_GET["send_title"]) : "";
	$get_title['title'] = isset($_GET["title"]) ? trim($_GET["title"]) : "";
	if($get_title['send_title']){
		$w3a_buf["title"] = @mb_convert_encoding($get_title["send_title"], "EUC-JP", constant("TO_ENCODING"));
	}elseif($get_title['title']){
		$w3a_buf["title"] = @mb_convert_encoding($get_title['title'], "EUC-JP", constant("TO_ENCODING"));
	}else{
		if(getcwd() == dirname(__FILE__) && isset($_GET["mogura_path"])){
			#$w3a_buf["title"] = WriteClass::get_title($w3a_buf["path"]);
		}else{
			$w3a_buf["title"] = WriteClass::get_title($w3a_buf["path"]);
		}
	}
	unset($get_title);

	//UserAgent
	if(isset($_SERVER["HTTP_USER_AGENT"])){
		$ua = WriteClass::quote_smart($_SERVER["HTTP_USER_AGENT"]);
		$sql = "SELECT ua_id FROM ".constant("DB_TABLE_UA")." WHERE ua_name = ".$ua.";";
		$res = $db->query($sql);
		WriteClass::check_err($res);
		$row = $res->fetchRow(DB_FETCHMODE_ASSOC);
		$w3a_buf["ua"] = $row["ua_id"];
		$res->free();
		if($w3a_buf["ua"] == ""){
			if(constant("ENC_FLG")) $ua = @mb_convert_encoding($ua, "EUC-JP", "ASCII,JIS,UTF-8,EUC-JP,SJIS");
			//UAɲ
			$sql = "INSERT INTO ".constant("DB_TABLE_UA")." (ua_name) values (".$ua.");";
			$res = $db->query($sql);
			WriteClass::check_err($res);
			//UA
			$sql = "SELECT ua_id FROM ".constant("DB_TABLE_UA")." WHERE ua_name = ".$ua.";";
			$res = $db->query($sql);
			WriteClass::check_err($res);
			$row = $res->fetchRow(DB_FETCHMODE_ASSOC);
			$w3a_buf["ua"] = $row["ua_id"];
			$res->free();
		}
	}
	
	//Language
	if(isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])){
		if(strpos($_SERVER['HTTP_ACCEPT_LANGUAGE'],';')){
			list($w3a_buf['lang']) =  explode(';',$_SERVER['HTTP_ACCEPT_LANGUAGE']);
		}else{
			$w3a_buf['lang'] = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
		}
		list($w3a_buf['lang']) = explode(',',$w3a_buf['lang']);
		$w3a_buf['lang'] = strtolower($w3a_buf['lang']);
	}
	
	//monitor
	$w3a_buf["monitor"] = isset($_GET["monitor"]) ? $_GET["monitor"] : "";
	
	//color
	$w3a_buf["color"] = isset($_GET["color"]) ? $_GET["color"] : "";
	
	//cookie
	$w3a_buf["cookie"] = isset($_GET["cookie"]) ? $_GET["cookie"] : "";
	
	//JavaScript
	$w3a_buf["js"] = isset($_GET["js"]) ? $_GET["js"] : "";
	
	//-------------------------------------
	//  ݽ
	//-------------------------------------
	if(isset($exclude["id"]))   if($write_flg && WriteClass::inc_array($w3a_buf["id"], $exclude["id"])){ $write_flg = false; }
	if(isset($exclude["host"])) if($write_flg && WriteClass::inc_array($w3a_buf["host"], $exclude["host"])){ $write_flg = false; }
	if(isset($exclude["host"])) if($write_flg && WriteClass::inc_array($w3a_buf["ip"], $exclude["host"])){ $write_flg = false; }
	if(isset($exclude["path"])) if($write_flg && WriteClass::inc_array($w3a_buf["path"], $exclude["path"])){ $write_flg = false; }
	if(isset($exclude["url"]))  if($write_flg && WriteClass::inc_array($w3a_buf["ref"], $exclude["url"])){ $write_flg = false; }
	if(isset($exclude["ua"]))   if($write_flg && WriteClass::inc_array($_SERVER["HTTP_USER_AGENT"], $exclude["ua"])){ $write_flg = false; }
	//к
	if($write_flg && constant("UNWRITE") > 0){
		$sql = "SELECT path FROM ".constant("DB_TABLE_LOG")
				." WHERE date >= DATE_ADD(now(),interval -".constant("UNWRITE")." SECOND)"
				." AND id = '".$w3a_buf["id"]."'"
				." order by date desc"
				." LIMIT 1;";
		$res = $db->query($sql);
		unset($row);
		$row = $res->fetchRow(DB_FETCHMODE_ASSOC);
		WriteClass::check_err($res);
		if($row["path"] && $row["path"] == $w3a_buf["path"]) $write_flg = false;
	}
	//-------------------------------------
	//  ɲ
	//-------------------------------------
	if($write_flg){
		$sql_k = "";
		$sql_v = "";
		while (list ($k, $v) = each ($w3a_buf)) {
			$v = trim($v);
			if($v == "") continue;
			
			$sql_k .= WriteClass::quote_smart($k, 1).",";
			$sql_v .= WriteClass::quote_smart($v).",";
		}
		$sql_k = "(".substr($sql_k,0,strlen($sql_k)-1).")";
		$sql_v = " VALUES (".substr($sql_v,0,strlen($sql_v)-1).")";
		$sql = "INSERT INTO ".constant("DB_TABLE_LOG")." ".$sql_k.$sql_v.";";
		if(constant("ENC_FLG")) $sql = @mb_convert_encoding($sql, "EUC-JP", "ASCII,JIS,UTF-8,EUC-JP,SJIS");
		$res = $db->query($sql);
		WriteClass::check_err($res);
		//ʾΥ
		if(constant("MAX_LOG")){
			$res = $db->query("SELECT no FROM ".constant("DB_TABLE_LOG")." order by no desc limit ".constant("MAX_LOG").",1;");
			if($res->numRows()){
				$row = $res->fetchRow(DB_FETCHMODE_ASSOC);
				$db->query("DELETE FROM ".constant("DB_TABLE_LOG")." WHERE no <= ".$row["no"].";");
			}
		}
	}

	//-------------------------------------
	//  󥿡
	//-------------------------------------
	$counter = 0;
	if(constant("COUNTER")){
		//ˡ
		$sql = "SELECT path FROM ".constant("DB_TABLE_LOG")." WHERE date like '".gmdate("Y-m-d", time()+constant("TIME_DIFF")*3600)."%'"." AND id = '".$w3a_buf["id"]."' LIMIT 1;";
		$res = $db->query($sql);
		WriteClass::check_err($res);
		//󥿡
		if($write_flg && $res->fetchRow()){
			$res = $db->query("SELECT * FROM ".constant("DB_COUNTER")." WHERE counter_date = '".gmdate("Y-m-d", time()+constant("TIME_DIFF")*3600)."' LIMIT 1;");
			if($res->fetchRow()){
				$db->query("UPDATE ".constant("DB_COUNTER")." SET counter_val=counter_val+1 WHERE counter_date = '".gmdate("Y-m-d", time()+constant("TIME_DIFF")*3600)."';");
			}else{
				$db->query("INSERT INTO ".constant("DB_COUNTER")." (counter_date,counter_val) VALUES ('".gmdate("Y-m-d", time()+constant("TIME_DIFF")*3600)."',1);");
			}
		}
		//󥿡
		$res = $db->query("SELECT SUM(counter_val) as counter FROM ".constant("DB_COUNTER")." LIMIT 1;");
		WriteClass::check_err($res);
		$row = $res->fetchRow(DB_FETCHMODE_ASSOC);
		$counter = $row["counter"];
	}
	
	//-------------------------------------
	//  DB³λ/å
	//-------------------------------------
	$db->query("UNLOCK TABLES");
	$db->disconnect();
	//ʸ󥳡ǥ
	@mb_internal_encoding($def_enc);
}
/*======================================*/
/* 󥿡                       */
/*======================================*/
if(constant("ACC_RUN")){
	// 󥿡ɽ
	if(constant("COUNTER")){
		if($mode == "img"){
			// PHP_WRITE_MODE [1]
			if(constant("COUNTER_TYPE") == 'txt'){
				WriteClass::mk_counter();
			}elseif(constant("COUNTER_TYPE") == 'img'){
				WriteClass::mk_counter($counter);
			}
		}else{
			// PHP_WRITE_MODE [0]
			if(constant("COUNTER_TYPE") == 'txt'){
				$counter = str_pad($counter, constant("COUNTER_DIGIT"), "0", STR_PAD_LEFT);
				$MOGU_COUNT = $counter;
			}elseif(constant("COUNTER_TYPE") == 'img'){
				$MOGU_COUNT = '<img src="'.constant("W_PATH").'?mode=php&counter='.$counter.'">';
			}
		}
		unset($w3a_buf, $row, $write_flg, $exclude, $include_path);

	// 󥿡ɽʤ
	}elseif($mode == "img"){
		header("Content-Type: image/gif");
		echo base64_decode("R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==");
		exit;
	}
}
?>
